import { AudioObject } from './audio-object';
export declare type DistortionType = 'clip' | 'foldback' | 'overflow';
export declare type DistortionOptions = {
    signal: AudioObject;
    threshold?: number | AudioObject;
    type?: DistortionType;
};
export declare class Distortion implements AudioObject {
    private _signal;
    private _threshold;
    private _type;
    constructor({ signal, threshold, type }: DistortionOptions);
    signal(): AudioObject;
    signal(value: AudioObject): void;
    threshold(): AudioObject;
    threshold(value: number | AudioObject): void;
    type(): DistortionType;
    type(value: DistortionType): void;
    tf(t: number): number;
}
