"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var audio_object_1 = require("./audio-object");
var Distortion = /** @class */ (function () {
    function Distortion(_a) {
        var signal = _a.signal, _b = _a.threshold, threshold = _b === void 0 ? 1 : _b, _c = _a.type, type = _c === void 0 ? 'clip' : _c;
        this._signal = signal;
        this._threshold = audio_object_1.toAudioObject(threshold);
        this._type = type;
    }
    Distortion.prototype.signal = function (value) {
        if (value === undefined)
            return this._signal;
        this._signal = value;
    };
    Distortion.prototype.threshold = function (value) {
        if (value === undefined)
            return this._threshold;
        this._threshold = audio_object_1.toAudioObject(value);
    };
    Distortion.prototype.type = function (value) {
        if (value === undefined)
            return this._type;
        this._type = value;
    };
    Distortion.prototype.tf = function (t) {
        var tr = this._threshold.tf(t);
        var s = this._signal.tf(t);
        if (this._type === 'clip') {
            if (-tr <= s && s <= tr)
                return s;
            if (s > tr)
                return tr;
            return -tr;
        }
        if (this._type === 'foldback') {
            if (-tr <= s && s <= tr)
                return s;
            if (s > tr)
                return 2 * tr - s;
            return -2 * tr - s;
        }
        if (this._type === 'overflow') {
            if (-tr <= s && s <= tr)
                return s;
            if (s > tr)
                return 2 * tr - s;
            return -2 * tr - s;
        }
        throw new Error('Distortion type not recognized');
    };
    return Distortion;
}());
exports.Distortion = Distortion;
