import { AudioObject } from './audio-object';
export declare type OscillatorType = 'sine' | 'square' | 'triangle' | 'sawthoot';
export declare type OscillatorOptions = {
    frequency: number;
    phase?: AudioObject | number;
    amplitude?: AudioObject | number;
    type?: OscillatorType;
};
export declare class Oscillator implements AudioObject {
    private _frequency;
    private _amplitude;
    private _phase;
    private _type;
    constructor({ frequency, phase, amplitude, type }: OscillatorOptions);
    frequency(): number;
    frequency(value: number): void;
    amplitude(): AudioObject;
    amplitude(value: number | AudioObject): void;
    phase(): AudioObject;
    phase(value: number | AudioObject): void;
    type(): OscillatorType;
    type(value: OscillatorType): void;
    tf(t: number): number;
}
